import partial from 'lodash.partial';
import { query } from './query';
import { withAdapter } from './with-adapter';
export var withEncryption = function withEncryption(context, encryption) {
  if (context.encryption != null) {
    throw Error("Read model encryption already assigned.");
  }

  context.encryption = encryption;
  return {
    query: partial(query, context),
    withAdapter: partial(withAdapter, context)
  };
};
//# sourceMappingURL=with-encryption.js.map