"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.shouldExecuteSideEffect = void 0;

var _lodash = _interopRequireDefault(require("lodash.isequal"));

var _makeAssertions = require("./make-assertions");

var _format = require("../../utils/format");

var shouldExecuteSideEffect = function shouldExecuteSideEffect(context, name) {
  for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }

  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be assigned if the test was executed.");
  }

  environment.addAssertion(function (resolve, reject, result, error) {
    if (error) {
      return reject(new Error("expected a value, but received an error " + error));
    }

    var expected = [name].concat(args);
    var index = result ? result.sideEffects.findIndex(function (executed) {
      return (0, _lodash["default"])(executed, expected);
    }) : -1;

    if (index >= 0) {
      return resolve(result);
    }

    return reject(new Error((0, _format.stringifyShouldExecuteSideEffectFailure)(expected, result.sideEffects)));
  });
  return (0, _makeAssertions.makeAssertions)(context);
};

exports.shouldExecuteSideEffect = shouldExecuteSideEffect;
//# sourceMappingURL=should-execute-side-effect.js.map